#include and lib might have to be set up before run this make file

SUFFIXES = .cpp

.SUFFIXES: $(SUFFIXES)

COMPILE = CL -c $(CCFLAGS) $(CPPFLAGS)
LINK = CL $(CCFLAGS) $(CPPFLAGS) $(LINKFLAGS)

.cpp.obj:
	$(COMPILE) $(OUTPUT_OPTION) $<

CPPFLAGS = -Ot -W4

mscdobj   = userinfo.obj userutil.obj cartesia.obj polation.obj \
            curvefit.obj pdinten.obj pdintena.obj fcomplex.obj \
            msfuncs.obj pdchifit.obj vibrate.obj meanpath.obj \
            phase.obj radmat.obj rotamat.obj mscdrun.obj \
            mscdruna.obj mscdrunb.obj mscdrunc.obj mscdrund.obj \
            mscdrune.obj mscdjob.obj mscdmain.obj \
            jobtime.obj userpc.obj
mscdexe   = mscd.exe

calchiobj = userinfo.obj userutil.obj cartesia.obj polation.obj \
            curvefit.obj pdinten.obj pdintena.obj \
            calchi.obj
calchiexe = calchi.exe

calnoxobj = userinfo.obj userutil.obj cartesia.obj polation.obj \
            curvefit.obj pdinten.obj pdintena.obj \
            calnox.obj
calnoxexe = calnox.exe

caldifobj = userinfo.obj userutil.obj cartesia.obj polation.obj \
            curvefit.obj pdinten.obj pdintena.obj \
            caldif.obj
caldifexe = caldif.exe

calfacobj = userinfo.obj userutil.obj polation.obj phase.obj \
            msfuncs.obj rotamat.obj fcomplex.obj scatter.obj \
            calfac.obj
calfacexe = calfac.exe

poconvobj = userinfo.obj userutil.obj potentia.obj poconv.obj
poconvexe = poconv.exe

psconvobj = userinfo.obj userutil.obj fcomplex.obj phase.obj psconv.obj
psconvexe = psconv.exe

rmconvobj = userinfo.obj userutil.obj radmat.obj rmconv.obj
rmconvexe = rmconv.exe

calmfpobj = userinfo.obj userutil.obj meanpath.obj calmfp.obj
calmfpexe = calmfp.exe

calvibobj = userinfo.obj userutil.obj vibrate.obj calvib.obj
calvibexe = calvib.exe

spconvobj = userinfo.obj userutil.obj polation.obj xpspec.obj \
            spconv.obj
spconvexe = spconv.exe

xpspeakobj = userinfo.obj userutil.obj polation.obj xpspec.obj \
            xpspeca.obj curvefit.obj xpspeak.obj
xpspeakexe = xpspeak.exe

mscdall : $(mscdexe) $(calchiexe) $(calnoxexe) $(caldifexe) \
          $(calfacexe) $(poconvexe) $(psconvexe) $(rmconvexe) \
          $(calmfpexe) $(calvibexe) $(spconvexe) $(xpspeakexe)

$(mscdexe) : $(mscdobj)
	$(LINK) $(mscdobj) -Fe$(mscdexe)

$(calchiexe) : $(calchiobj)
	$(LINK) $(calchiobj) -Fe$(calchiexe)

$(calnoxexe) : $(calnoxobj)
	$(LINK) $(calnoxobj) -Fe$(calnoxexe)

$(caldifexe) : $(caldifobj)
	$(LINK) $(caldifobj) -Fe$(caldifexe)

$(calfacexe) : $(calfacobj)
	$(LINK) $(calfacobj) -Fe$(calfacexe)

$(poconvexe) : $(poconvobj)
	$(LINK) $(poconvobj) -Fe$(poconvexe)

$(psconvexe) : $(psconvobj)
	$(LINK) $(psconvobj) -Fe$(psconvexe)

$(rmconvexe) : $(rmconvobj)
	$(LINK) $(rmconvobj) -Fe$(rmconvexe)

$(calmfpexe) : $(calmfpobj)
	$(LINK) $(calmfpobj) -Fe$(calmfpexe)

$(calvibexe) : $(calvibobj)
	$(LINK) $(calvibobj) -Fe$(calvibexe)

$(spconvexe) : $(spconvobj)
	$(LINK) $(spconvobj) -Fe$(spconvexe)

$(xpspeakexe) : $(xpspeakobj)
	$(LINK) $(xpspeakobj) -Fe$(xpspeakexe)

